using System;
using System.Runtime.InteropServices;
using System.ComponentModel;
using System.Windows.Forms;
using Outlook = Microsoft.Office.Interop.Outlook;

namespace WinFormOverWordInOutlook
{
    /// <summary>
    ///   Add-in Express Add-in Module
    /// </summary>
    [GuidAttribute("76213EBC-9B19-4F1E-B878-B61ABE28312D"), ProgId("WinFormOverWordInOutlook.AddinModule"), RunInstaller(true)]
    public class AddinModule : AddinExpress.MSO.ADXAddinModule
    {
		[DllImport("user32.dll")]
		public static extern int GetForegroundWindow();

		[DllImport("user32.dll")]
		public static extern int SetParent(int hWndChild, int hWndNewParent);


		public AddinModule()
        {
            InitializeComponent();
        }

		private AddinExpress.MSO.ADXOlInspectorCommandBar adxOlInspectorCommandBar1;
		private AddinExpress.MSO.ADXCommandBarButton adxCommandBarButton1;
 
        #region Component Designer generated code
        /// <summary>
        /// Required by designer
        /// </summary>
        private System.ComponentModel.IContainer components;
 
        /// <summary>
        /// Required by designer support - do not modify
        /// the following method
        /// </summary>
        private void InitializeComponent()
        {
            this.components = new System.ComponentModel.Container();
            this.adxOlInspectorCommandBar1 = new AddinExpress.MSO.ADXOlInspectorCommandBar(this.components);
            this.adxCommandBarButton1 = new AddinExpress.MSO.ADXCommandBarButton(this.components);
            // 
            // adxOlInspectorCommandBar1
            // 
            this.adxOlInspectorCommandBar1.CommandBarName = "Inspector Bar";
            this.adxOlInspectorCommandBar1.CommandBarTag = "d94cd580-c51a-4085-a56a-65889257e481";
            this.adxOlInspectorCommandBar1.Controls.Add(this.adxCommandBarButton1);
            this.adxOlInspectorCommandBar1.Position = AddinExpress.MSO.ADXMsoBarPosition.adxMsoBarTop;
            this.adxOlInspectorCommandBar1.Temporary = true;
            this.adxOlInspectorCommandBar1.UpdateCounter = 5;
            // 
            // adxCommandBarButton1
            // 
            this.adxCommandBarButton1.Caption = "Show Form";
            this.adxCommandBarButton1.ControlTag = "9a30b14e-a06f-43e3-87c5-af3a8064181b";
            this.adxCommandBarButton1.ImageTransparentColor = System.Drawing.Color.Transparent;
            this.adxCommandBarButton1.Temporary = true;
            this.adxCommandBarButton1.UpdateCounter = 2;
            this.adxCommandBarButton1.Click += new AddinExpress.MSO.ADXClick_EventHandler(this.adxCommandBarButton1_Click);
            // 
            // AddinModule
            // 
            this.AddinName = "WinFormOverWordInOutlook";
            this.SupportedApps = AddinExpress.MSO.ADXOfficeHostApp.ohaOutlook;
            this.AddinBeginShutdown += new AddinExpress.MSO.ADXEvents_EventHandler(this.AddinModule_AddinBeginShutdown);
            this.OnSendMessage += new AddinExpress.MSO.ADXSendMessage_EventHandler(this.AddinModule_OnSendMessage);
            this.AddinStartupComplete += new AddinExpress.MSO.ADXEvents_EventHandler(this.AddinModule_AddinStartupComplete);
            this.AddinInitialize += new AddinExpress.MSO.ADXEvents_EventHandler(this.AddinModule_AddinInitialize);

		}
        #endregion
 
        #region ADX automatic code
 
        // Required by Add-in Express - do not modify
        // the methods within this region
 
        public override System.ComponentModel.IContainer GetContainer()
        {
            if (components == null)
                components = new System.ComponentModel.Container();
            return components;
        }
 
        [ComRegisterFunctionAttribute]
        public static void AddinRegister(Type t)
        {
            AddinExpress.MSO.ADXAddinModule.ADXRegister(t);
        }
 
        [ComUnregisterFunctionAttribute]
        public static void AddinUnregister(Type t)
        {
            AddinExpress.MSO.ADXAddinModule.ADXUnregister(t);
        }
 
        public override void UninstallControls()
        {
            base.UninstallControls();
        }

        #endregion

        public Outlook._Application OutlookApp
        {
            get
            {
                return (HostApplication as Outlook._Application);
            }
        }

        private const int WM_USER = 0x0400;
		private const int WM_MYMESSAGES1 = WM_USER + 1001;
        private const int WM_MYMESSAGES2 = WM_USER + 1002;

		private void adxCommandBarButton1_Click(object sender)
		{
            this.SendMessage(WM_MYMESSAGES1, IntPtr.Zero, IntPtr.Zero);
		}

		private void AddinModule_AddinInitialize(object sender, System.EventArgs e)
		{
			//
		}

		private void AddinModule_AddinBeginShutdown(object sender, System.EventArgs e)
		{
            //
		}

		private void AddinModule_AddinStartupComplete(object sender, System.EventArgs e)
		{
			//
		}

        private class ParentWindow : IWin32Window
        {
            public ParentWindow()
            {
            }

            public IntPtr Handle
            {
                get
                {
                    return new IntPtr(GetForegroundWindow());
                }
            }
        }

        private Form1 myForm = null;
        private ParentWindow parent = new ParentWindow();

        private void AddinModule_OnSendMessage(object sender, AddinExpress.MSO.ADXSendMessageEventArgs e)
        {
            switch (e.Message)
            {
                case WM_MYMESSAGES1:
                    lock (this)
                    {
                        try
                        {
                            if (myForm == null)
                                myForm = new Form1();

                            // Use this code to show a non-modal form.
                            //SetParent(myForm.Handle.ToInt32(), GetForegroundWindow());
                            myForm.ShowDialog(parent);
                        }
                        catch
                        {
                        }
                    }
                    break;
                case WM_MYMESSAGES2:
                    lock (this)
                    {
                        myForm = null;
                    }
                    break;
            }
        }
	}
}

